//Provided by Grotius d.d. 9-6-2019
//GPL2

//PROGRAM PURPOSE :
//QT OpenGL example how to draw a horizontal line by clicking a button in a custom QT C++ gui.
//
//PROGRAM INFO :
//2. glOrtho(-10, 10, -10, 10, -1.0, 3.5);          (changing this value's will provide zoom in and zoom out function's)
//3. auto dv = new QDoubleValidator(0.0, 5.0, 2);   (will result that the text entry box can only be used for typing in float value's instead of characters)
//4. compatible with the latest OpenGLWidget, compatible with QT version 5.12.2
//5. have fun to expand this code to your needs, and give code back once in a while, that is what GPL2 is all about.

#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "oglwidget.h"
#include <QDebug>
#include <QString>
#include <stdio.h>
#include <QWidget>
#include <QOpenGLWidget>
#include <QtOpenGL>

#include <QWheelEvent>
#include <QListView>


int z = 5;


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    float feedrate = ui->lineEdit_2->text().toFloat();
    float power = ui->lineEdit_3->text().toFloat();
    float kerf = ui->lineEdit_5->text().toFloat();
    leadin = ui->lineEdit_6->text().toFloat();

    linewidth = ui->lineEdit->text().toFloat();            //the text input label is a text, but we convert it directly to float.
    lineheight = ui->lineEdit_4->text().toFloat();
    qDebug() << linewidth << lineheight;                                 //print the output in the console.

    //g-code:
    ui->plainTextEdit_3->setPlainText("(postprocessor for linuxcnc plasma)\nG21 (Metric)\nG40 G90 G64P0.01\nF1 S1\n");

    //apply kerf offset:
    ui->plainTextEdit_3->appendPlainText("G42 D" + QString::number(kerf/2));

    //Lead in:
    ui->plainTextEdit_3->appendPlainText("G0 X0 Y0");
    ui->plainTextEdit_3->appendPlainText("M3 S" + QString::number(power));

    QString str1 = "G1 X" + QString::number(linewidth) + " Y0" + " F" + QString::number(feedrate);
    ui->plainTextEdit_3->appendPlainText(str1);

    QString str2 = "X" + QString::number(linewidth) + " Y" + QString::number(lineheight);
    ui->plainTextEdit_3->appendPlainText(str2);

    QString str3 = "X0 Y" + QString::number(lineheight);
    ui->plainTextEdit_3->appendPlainText(str3);

    ui->plainTextEdit_3->appendPlainText("X0 Y0");
    ui->plainTextEdit_3->appendPlainText("G40");
    ui->plainTextEdit_3->appendPlainText("M5");
    ui->plainTextEdit_3->appendPlainText("M30");

}

void MainWindow::on_lineEdit_textEdited(const QString &arg1)
{
    auto dv = new QDoubleValidator(0.0, 5.0, 2);            // set the text entry label valid for float input only, [0, 5] with 2 decimals of precision
    ui->lineEdit->setValidator(dv);
}

